#demo for receive message with Ordered Queue Wrapper

import sys
import os
import time
import threading
from mns.account import Account
from mns.queue import *
from ordered_queue import *

g_endpoint = ""
g_accessKeyId = ""
g_accessKeySecret = ""
g_testQueueName = "mns-orderedqueue"

if __name__ == "__main__":
    #create queue
    myAccount = Account(g_endpoint, g_accessKeyId, g_accessKeySecret)
    myQueue = myAccount.get_queue(g_testQueueName)

    #init orderedQueue
    seqIdConfig = {"localFileName":"/tmp/mns_receive_message_seq_id"}
    seqIdPS = LocalDiskStorage(seqIdConfig)
    orderedQueue = OrderedQueueWrapper(myQueue, receiveSeqIdPersistStorage = seqIdPS)

    #Receive Message
    count = 0
    while count < 20:
        wait_seconds = 10
        try:
            recv_msg = orderedQueue.ReceiveMessageInOrder(wait_seconds)
            if (recv_msg != -1):
                print "orderedqueuewrapper receive message body is %s" % recv_msg.message_body
                myQueue.delete_message(recv_msg.receipt_handle)
            else:
                orderedQueue.GetMsgBuffer().CleanBuffer() #if buffer is full, clean buffer
        except MNSExceptionBase, e:
            print "receive message fail with orderedqueue!\nException:%s\n\n" % e
            time.sleep(1)
            continue

        count = count + 1
        time.sleep(1)
    print "Finish receive %d messages" % count
    
    #delete queue
    orderedQueue.StopCheckThread()  #IMPORTANT!!! close the checkThread of orderedqueue.
    myQueue.delete()
 
