#demo for send messgae with OrderedQueueWrapper

import sys
import os
import time
import threading
from mns.account import Account
from mns.queue import *
from ordered_queue import *

g_endpoint = ""
g_accessKeyId = ""
g_accessKeySecret = ""
g_testQueueName = "mns-orderedqueue"

if __name__ == "__main__":
    myAccount = Account(g_endpoint, g_accessKeyId, g_accessKeySecret)
    myQueue = myAccount.get_queue(g_testQueueName)
    queueMeta = QueueMeta()
    queueMeta.set_visibilitytimeout(100)
    queueMeta.set_maximum_message_size(10240)
    queueMeta.set_message_retention_period(3600)
    queueMeta.set_delay_seconds(10)
    queueMeta.set_polling_wait_seconds(20)
    try:
        queueUrl = myQueue.create(queueMeta)
        print "Create Queue Succeed!\nQueueURL:%s\n\n" % queueUrl
    except MNSExceptionBase, e:
        print "Create Queue Fail!\nException:%s\n\n" % e
        sys.exit(1)

    #init orderedQueue
    sendSeqIdConfig = {"localFileName":"/tmp/mns_send_message_seq_id"}
    sendSeqIdPS = LocalDiskStorage(sendSeqIdConfig)
    orderedQueue = OrderedQueueWrapper(myQueue, sendSeqIdPersistStroage = sendSeqIdPS)

    #SendMessage
    count = 0
    while count < 20:
        msg_body = str(count)
        message = Message(msg_body)
        message.set_delayseconds(0)
        message.set_priority(10)
        try:
            print "orderedqueuewrapper: send message body %s" % message.message_body
            orderedQueue.SendMessageInOrder(message)
        except MNSExceptionBase, e:
            print "send message fail with orderedqueue!\nException:%s\n\n" % e
            orderedQueue.StopCheckThread()
            sys.exit(1)
        count = count + 1
        time.sleep(1)
    print "Finish send %d messages" % count
    orderedQueue.StopCheckThread() 
